using System;

namespace MikaiLaza
{
    class Program
    {
        public static void ispisiMat(int [,] m)
        {
            for (int i = 0; i < m.GetLength(0); i++)
            {
                Console.WriteLine();
                for (int J = 0; J < m.GetLength(1); J++)
                {
                    Console.WriteLine(m[i, J] + ",") ;
                }
            }
        }


        public static int brojStanja(int [,] abt,int mk, int lz)
        {
            int brStanja = 0;
            int stanje = 0;
            

            while (mk != lz)
            {
                int max = -1111111;
                int maxi = 0;
                for (int i = 0; i < abt.GetLength(0); i++)
                {
                    for (int J = 0; J < abt.GetLength(1); J++)
                    {
                        if (abt[i, 0] == mk)
                        {
                            if (abt[i, 1] - mk > max)
                            {
                                max = abt[i, 1]-mk;
                                maxi = i;
                            }
                        }
                    }
                }

                mk = abt[maxi, 1];
                if (abt[maxi, 2] != stanje)
                {
                    stanje = abt[maxi, 2];
                    brStanja++;
                }
            }

            return brStanja;
        }

        static void Main(string[] args)
        {
            var unos = Console.ReadLine();
            var vrednosti = unos.Split(" ");
            int N = int.Parse(vrednosti[0]);
            int M = int.Parse(vrednosti[1]);

            int[,] abt = new int[M,3];


            for (int i = 0; i < M; i++)
            {
                var unosNiza = Console.ReadLine();
                var vrednostiNiza = unosNiza.Split(" ");
                for (int j = 0; j < 3; j++)
                {
                    abt[i,j] = int.Parse(vrednostiNiza[j]);
                }
            }

            var unosA = Console.ReadLine();
            var vrednostiA = unosA.Split(" ");
            int Mika = int.Parse(vrednostiA[0]);
            int Laza = int.Parse(vrednostiA[1]);

            Console.WriteLine(brojStanja(abt,Mika,Laza));

            Console.ReadLine();
        }
    }
}